/* MF_led_fade
   Ez a példa megmutatja, hogyan halványítsuk a LED fényerejét
   a D11 PWM kimenet és az analogWrite() függvény használatával.
   A Multifunkciós kártya a LED-ek katódját vezérli, ezért a PWM
   kitöltés értékét kompementálni kell (255-ből ki kell vonni).

   Forrás: Harsányi Réka - Juhász Márton András,
   Fizikai számítástechnika: elektronikai alapok és Arduino programozás
   Az eredeti programot átdolgoztuk a Multifunkciós kártyához
*/

// létrehozzuk az állandókat, az integer egész számot tárol:
#define led      11     // D11-re van kötve a LED
int brightness = 0;     // fényerő értéke
int fadeAmount = 5;     // a változás léptéke

void setup() {
  setup_7seg();         // Multifunkciós kártya inicializálás
  pinMode(led, OUTPUT); // D11 legyen kimenet
}

void loop() {
  // fényerő értékét hozzárendeljük a LED kimenethez:
  analogWrite(led, 255 - brightness);
  // megnöveljük a fényerő értékét az általunk megadott
  // léptékben, mindig, mikor lefut a loop, hozzáadódik
  brightness = brightness + fadeAmount;
  // a végén megfordítjuk a változás irányát:
  if (brightness == 0 || brightness == 255) {
    fadeAmount = -fadeAmount ;
  }
  // Várunk, hogy a szemünk is láthassa a változást:
  delay(50);
}

/**************************************************
   A Multifunkciós kártya 7-szegmens kijelzőjének
   inicializálása és elsötétítése
 **************************************************/
#define LATCH_DIO 4
#define CLK_DIO   7
#define DATA_DIO  8
void setup_7seg(void) {
  /* Vezérlő lábak konfigurálása */
  pinMode(LATCH_DIO, OUTPUT);
  pinMode(CLK_DIO, OUTPUT);
  pinMode(DATA_DIO, OUTPUT);
  digitalWrite(LATCH_DIO, LOW);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, 0xFF);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, 0x00 );
  digitalWrite(LATCH_DIO, HIGH);
}
