/* MF_led_fade_exp
   Ebben a programban a LED fényerejét nemlineárisan változtatjuk
   a D11 PWM kimenet és az analogWrite() függvény
   használatával.
   A Multifunkciós kártya a LED-ek katódját vezérli, ezért a PWM
   kitöltés értékét kompementálni kell (255-ből ki kell vonni).
*/

// létrehozzuk az állandókat, az integer egész számot tárol:
#define led      11          // D11-re van kötve a LED
uint16_t idx = 0;            // Index a kitöltési tényezők számításához
uint16_t next_sqr = 1;       // A következő négyzetszám
uint16_t sqr_step = 3;       // Növekmény a következő négyzetszám kiszámításához

void setup() {
  pinMode(led, OUTPUT);      // D11 legyen kimenet
  setup_7seg();              // Multifunkciós kártya inicializálás
}

void loop() {
  analogWrite(led, 255 - (next_sqr >> 4));
  idx++;                     // A futó index növelése
  if (idx < 63) {            // Az első 63 lépésben felfelé lépünk
    next_sqr += sqr_step;
    sqr_step += 2;
  } else if (idx < 125) {    // A második 63 lépésben lefelé lépünk
    sqr_step -= 2;
    next_sqr -= sqr_step;
  } else idx = 0;            // Új periódus kezdődik
  delay(25);
}

/**************************************************
 * A Multifunkciós kártya 7-szegmens kijelzőjének * 
 * inicializálása és elsötétítése                 *
 **************************************************/
#define LATCH_DIO 4
#define CLK_DIO   7
#define DATA_DIO  8
void setup_7seg(void) {
  /* Vezérlő lábak konfigurálása */
  pinMode(LATCH_DIO, OUTPUT);
  pinMode(CLK_DIO, OUTPUT);
  pinMode(DATA_DIO, OUTPUT);
  digitalWrite(LATCH_DIO, LOW);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, 0xFF);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, 0x00 );
  digitalWrite(LATCH_DIO, HIGH);
}
