/* led_fade
 * Ez a példa megmutatja, hogyan halványítsuk a LED fényerejét
 * a D5 PWM kimenet és az analogWrite() függvény használatával.
 * 
 * Forrás: Harsányi Réka - Juhász Márton András,
 * Fizikai számítástechnika: elektronikai alapok és
 * Arduino programozás
 */

// létrehozzuk az állandókat, az integer egész számot tárol:
#define led      5      // D5-re van kötve a LED
int brightness = 0;     // fényerő értéke
int fadeAmount = 5;     // a változás léptéke

void setup() {
  pinMode(led, OUTPUT); // D5 legyen kimenet
}
void loop() {
  // fényerő értékét hozzárendeljük a LED kimenethez:
  analogWrite(led, brightness);
  // megnöveljük a fényerő értékét az általunk megadott
  // léptékben, mindig, mikor lefut a loop, hozzáadódik
  brightness = brightness + fadeAmount;
  // a végén megfordítjuk a változás irányát:
  if (brightness == 0 || brightness == 255) {
    fadeAmount = -fadeAmount ;
  }
  // Várunk, hogy a szemünk is láthassa a változást:
  delay(50);
}
